import { L as t, a as f, S as c, i as x, n as p, s as y, e as g, E as S, b as u, k as j, c as v, d as b, x as L, f as w, t as C, g as k } from "./ref-CegYCGK_.js";
function n(e) {
  return new f(c.define(e));
}
function a(e) {
  return import("./index-BRFBMkPu.js").then((o) => o.sql({ dialect: o[e] }));
}
const P = [
  // New-style language modes
  /* @__PURE__ */ t.of({
    name: "C",
    extensions: ["c", "h", "ino"],
    load() {
      return import("./index-B0k1ehY-.js").then((e) => e.cpp());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "C++",
    alias: ["cpp"],
    extensions: ["cpp", "c++", "cc", "cxx", "hpp", "h++", "hh", "hxx"],
    load() {
      return import("./index-B0k1ehY-.js").then((e) => e.cpp());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "CQL",
    alias: ["cassandra"],
    extensions: ["cql"],
    load() {
      return a("Cassandra");
    }
  }),
  /* @__PURE__ */ t.of({
    name: "CSS",
    extensions: ["css"],
    load() {
      return import("./index-B6s_B5c5.js").then((e) => e.css());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "HTML",
    alias: ["xhtml"],
    extensions: ["html", "htm", "handlebars", "hbs"],
    load() {
      return import("./index-CANBRbRi.js").then((e) => e.html());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Java",
    extensions: ["java"],
    load() {
      return import("./index-2V7AOaBh.js").then((e) => e.java());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "JavaScript",
    alias: ["ecmascript", "js", "node"],
    extensions: ["js", "mjs", "cjs"],
    load() {
      return import("./index-CZn_lLVh.js").then((e) => e.javascript());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "JSON",
    alias: ["json5"],
    extensions: ["json", "map"],
    load() {
      return import("./index-Ce5GiMm6.js").then((e) => e.json());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "JSX",
    extensions: ["jsx"],
    load() {
      return import("./index-CZn_lLVh.js").then((e) => e.javascript({ jsx: !0 }));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "LESS",
    extensions: ["less"],
    load() {
      return import("./index-CLyoHu3G.js").then((e) => e.less());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Liquid",
    extensions: ["liquid"],
    load() {
      return import("./index-Dm45gTDJ.js").then((e) => e.liquid());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "MariaDB SQL",
    load() {
      return a("MariaSQL");
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Markdown",
    extensions: ["md", "markdown", "mkd"],
    load() {
      return import("./index-BaOTr30t.js").then((e) => e.markdown());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "MS SQL",
    load() {
      return a("MSSQL");
    }
  }),
  /* @__PURE__ */ t.of({
    name: "MySQL",
    load() {
      return a("MySQL");
    }
  }),
  /* @__PURE__ */ t.of({
    name: "PHP",
    extensions: ["php", "php3", "php4", "php5", "php7", "phtml"],
    load() {
      return import("./index-COA8KVRv.js").then((e) => e.php());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "PLSQL",
    extensions: ["pls"],
    load() {
      return a("PLSQL");
    }
  }),
  /* @__PURE__ */ t.of({
    name: "PostgreSQL",
    load() {
      return a("PostgreSQL");
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Python",
    extensions: ["BUILD", "bzl", "py", "pyw"],
    filename: /^(BUCK|BUILD)$/,
    load() {
      return import("./index-CF6fbDFE.js").then((e) => e.python());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Rust",
    extensions: ["rs"],
    load() {
      return import("./index-CcdaU_Z4.js").then((e) => e.rust());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Sass",
    extensions: ["sass"],
    load() {
      return import("./index-DrvQuALJ.js").then((e) => e.sass({ indented: !0 }));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "SCSS",
    extensions: ["scss"],
    load() {
      return import("./index-DrvQuALJ.js").then((e) => e.sass());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "SQL",
    extensions: ["sql"],
    load() {
      return a("StandardSQL");
    }
  }),
  /* @__PURE__ */ t.of({
    name: "SQLite",
    load() {
      return a("SQLite");
    }
  }),
  /* @__PURE__ */ t.of({
    name: "TSX",
    extensions: ["tsx"],
    load() {
      return import("./index-CZn_lLVh.js").then((e) => e.javascript({ jsx: !0, typescript: !0 }));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "TypeScript",
    alias: ["ts"],
    extensions: ["ts", "mts", "cts"],
    load() {
      return import("./index-CZn_lLVh.js").then((e) => e.javascript({ typescript: !0 }));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "WebAssembly",
    extensions: ["wat", "wast"],
    load() {
      return import("./index-BYEoWJPT.js").then((e) => e.wast());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "XML",
    alias: ["rss", "wsdl", "xsd"],
    extensions: ["xml", "xsl", "xsd", "svg"],
    load() {
      return import("./index--3l5jbKV.js").then((e) => e.xml());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "YAML",
    alias: ["yml"],
    extensions: ["yaml", "yml"],
    load() {
      return import("./index-BnKhHdCd.js").then((e) => e.yaml());
    }
  }),
  // Legacy modes ported from CodeMirror 5
  /* @__PURE__ */ t.of({
    name: "APL",
    extensions: ["dyalog", "apl"],
    load() {
      return import("./apl-B2DGVGxc.js").then((e) => n(e.apl));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "PGP",
    alias: ["asciiarmor"],
    extensions: ["asc", "pgp", "sig"],
    load() {
      return import("./asciiarmor-2LVJmxlE.js").then((e) => n(e.asciiArmor));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "ASN.1",
    extensions: ["asn", "asn1"],
    load() {
      return import("./asn1-DgPB8WTL.js").then((e) => n(e.asn1({})));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Asterisk",
    filename: /^extensions\.conf$/i,
    load() {
      return import("./asterisk-BACGokCw.js").then((e) => n(e.asterisk));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Brainfuck",
    extensions: ["b", "bf"],
    load() {
      return import("./brainfuck-CXliIoJ_.js").then((e) => n(e.brainfuck));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Cobol",
    extensions: ["cob", "cpy"],
    load() {
      return import("./cobol-BEWqv71R.js").then((e) => n(e.cobol));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "C#",
    alias: ["csharp", "cs"],
    extensions: ["cs"],
    load() {
      return import("./clike-BVPm0PS8.js").then((e) => n(e.csharp));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Clojure",
    extensions: ["clj", "cljc", "cljx"],
    load() {
      return import("./clojure-BBerApoz.js").then((e) => n(e.clojure));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "ClojureScript",
    extensions: ["cljs"],
    load() {
      return import("./clojure-BBerApoz.js").then((e) => n(e.clojure));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Closure Stylesheets (GSS)",
    extensions: ["gss"],
    load() {
      return import("./css-DOG_zngC.js").then((e) => n(e.gss));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "CMake",
    extensions: ["cmake", "cmake.in"],
    filename: /^CMakeLists\.txt$/,
    load() {
      return import("./cmake-CuaCgAKt.js").then((e) => n(e.cmake));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "CoffeeScript",
    alias: ["coffee", "coffee-script"],
    extensions: ["coffee"],
    load() {
      return import("./coffeescript-DRavyzEJ.js").then((e) => n(e.coffeeScript));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Common Lisp",
    alias: ["lisp"],
    extensions: ["cl", "lisp", "el"],
    load() {
      return import("./commonlisp-CLUKnGEQ.js").then((e) => n(e.commonLisp));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Cypher",
    extensions: ["cyp", "cypher"],
    load() {
      return import("./cypher-BPfZ95eU.js").then((e) => n(e.cypher));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Cython",
    extensions: ["pyx", "pxd", "pxi"],
    load() {
      return import("./python-DRVtUz1-.js").then((e) => n(e.cython));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Crystal",
    extensions: ["cr"],
    load() {
      return import("./crystal-ClQK8jha.js").then((e) => n(e.crystal));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "D",
    extensions: ["d"],
    load() {
      return import("./d-BU74mogo.js").then((e) => n(e.d));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Dart",
    extensions: ["dart"],
    load() {
      return import("./clike-BVPm0PS8.js").then((e) => n(e.dart));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "diff",
    extensions: ["diff", "patch"],
    load() {
      return import("./diff-Cg9d_RX2.js").then((e) => n(e.diff));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Dockerfile",
    filename: /^Dockerfile$/,
    load() {
      return import("./dockerfile-BYddBeCk.js").then((e) => n(e.dockerFile));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "DTD",
    extensions: ["dtd"],
    load() {
      return import("./dtd-DEHOnR61.js").then((e) => n(e.dtd));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Dylan",
    extensions: ["dylan", "dyl", "intr"],
    load() {
      return import("./dylan-BXYIjc86.js").then((e) => n(e.dylan));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "EBNF",
    load() {
      return import("./ebnf-Xa2PN7SI.js").then((e) => n(e.ebnf));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "ECL",
    extensions: ["ecl"],
    load() {
      return import("./ecl-tdt8ZNQI.js").then((e) => n(e.ecl));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "edn",
    extensions: ["edn"],
    load() {
      return import("./clojure-BBerApoz.js").then((e) => n(e.clojure));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Eiffel",
    extensions: ["e"],
    load() {
      return import("./eiffel-BJAUEbNe.js").then((e) => n(e.eiffel));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Elm",
    extensions: ["elm"],
    load() {
      return import("./elm-CNT9vbN0.js").then((e) => n(e.elm));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Erlang",
    extensions: ["erl"],
    load() {
      return import("./erlang-Cjb6qdzf.js").then((e) => n(e.erlang));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Esper",
    load() {
      return import("./sql-DvQrHKxs.js").then((e) => n(e.esper));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Factor",
    extensions: ["factor"],
    load() {
      return import("./factor-BNnQR5F-.js").then((e) => n(e.factor));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "FCL",
    load() {
      return import("./fcl-9QxdeMPH.js").then((e) => n(e.fcl));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Forth",
    extensions: ["forth", "fth", "4th"],
    load() {
      return import("./forth-BmxRyE9S.js").then((e) => n(e.forth));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Fortran",
    extensions: ["f", "for", "f77", "f90", "f95"],
    load() {
      return import("./fortran-CjBVm01y.js").then((e) => n(e.fortran));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "F#",
    alias: ["fsharp"],
    extensions: ["fs"],
    load() {
      return import("./mllike-1yy7Y7jE.js").then((e) => n(e.fSharp));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Gas",
    extensions: ["s"],
    load() {
      return import("./gas-BdfkXJT_.js").then((e) => n(e.gas));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Gherkin",
    extensions: ["feature"],
    load() {
      return import("./gherkin-CJuwpceU.js").then((e) => n(e.gherkin));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Go",
    extensions: ["go"],
    load() {
      return import("./go-CASVrepC.js").then((e) => n(e.go));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Groovy",
    extensions: ["groovy", "gradle"],
    filename: /^Jenkinsfile$/,
    load() {
      return import("./groovy-D4nO9wOG.js").then((e) => n(e.groovy));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Haskell",
    extensions: ["hs"],
    load() {
      return import("./haskell-Bvt3Qq1t.js").then((e) => n(e.haskell));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Haxe",
    extensions: ["hx"],
    load() {
      return import("./haxe-DO4UykDS.js").then((e) => n(e.haxe));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "HXML",
    extensions: ["hxml"],
    load() {
      return import("./haxe-DO4UykDS.js").then((e) => n(e.hxml));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "HTTP",
    load() {
      return import("./http-Bfa8vDY2.js").then((e) => n(e.http));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "IDL",
    extensions: ["pro"],
    load() {
      return import("./idl-B6TRFYjl.js").then((e) => n(e.idl));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "JSON-LD",
    alias: ["jsonld"],
    extensions: ["jsonld"],
    load() {
      return import("./javascript-BfU4-Hb5.js").then((e) => n(e.jsonld));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Jinja2",
    extensions: ["j2", "jinja", "jinja2"],
    load() {
      return import("./jinja2-DnB6dQmV.js").then((e) => n(e.jinja2));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Julia",
    extensions: ["jl"],
    load() {
      return import("./julia-DpvXAuO6.js").then((e) => n(e.julia));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Kotlin",
    extensions: ["kt", "kts"],
    load() {
      return import("./clike-BVPm0PS8.js").then((e) => n(e.kotlin));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "LiveScript",
    alias: ["ls"],
    extensions: ["ls"],
    load() {
      return import("./livescript-D0VJUStY.js").then((e) => n(e.liveScript));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Lua",
    extensions: ["lua"],
    load() {
      return import("./lua-D3vfQQWe.js").then((e) => n(e.lua));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "mIRC",
    extensions: ["mrc"],
    load() {
      return import("./mirc-D2ogSYjQ.js").then((e) => n(e.mirc));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Mathematica",
    extensions: ["m", "nb", "wl", "wls"],
    load() {
      return import("./mathematica-jaRHnSxC.js").then((e) => n(e.mathematica));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Modelica",
    extensions: ["mo"],
    load() {
      return import("./modelica-sUU7KDdm.js").then((e) => n(e.modelica));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "MUMPS",
    extensions: ["mps"],
    load() {
      return import("./mumps-CQoS1kWX.js").then((e) => n(e.mumps));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Mbox",
    extensions: ["mbox"],
    load() {
      return import("./mbox-qbC1IRn_.js").then((e) => n(e.mbox));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Nginx",
    filename: /nginx.*\.conf$/i,
    load() {
      return import("./nginx-CNi6q0Vf.js").then((e) => n(e.nginx));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "NSIS",
    extensions: ["nsh", "nsi"],
    load() {
      return import("./nsis-DkHQ1jvU.js").then((e) => n(e.nsis));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "NTriples",
    extensions: ["nt", "nq"],
    load() {
      return import("./ntriples-CsNjv2QF.js").then((e) => n(e.ntriples));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Objective-C",
    alias: ["objective-c", "objc"],
    extensions: ["m"],
    load() {
      return import("./clike-BVPm0PS8.js").then((e) => n(e.objectiveC));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Objective-C++",
    alias: ["objective-c++", "objc++"],
    extensions: ["mm"],
    load() {
      return import("./clike-BVPm0PS8.js").then((e) => n(e.objectiveCpp));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "OCaml",
    extensions: ["ml", "mli", "mll", "mly"],
    load() {
      return import("./mllike-1yy7Y7jE.js").then((e) => n(e.oCaml));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Octave",
    extensions: ["m"],
    load() {
      return import("./octave-CQUUBW35.js").then((e) => n(e.octave));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Oz",
    extensions: ["oz"],
    load() {
      return import("./oz-C7wSnf20.js").then((e) => n(e.oz));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Pascal",
    extensions: ["p", "pas"],
    load() {
      return import("./pascal-CClyGcR5.js").then((e) => n(e.pascal));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Perl",
    extensions: ["pl", "pm"],
    load() {
      return import("./perl-B4bSCe1C.js").then((e) => n(e.perl));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Pig",
    extensions: ["pig"],
    load() {
      return import("./pig-DV2v6Zgn.js").then((e) => n(e.pig));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "PowerShell",
    extensions: ["ps1", "psd1", "psm1"],
    load() {
      return import("./powershell-DkYVfTzP.js").then((e) => n(e.powerShell));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Properties files",
    alias: ["ini", "properties"],
    extensions: ["properties", "ini", "in"],
    load() {
      return import("./properties-Dn9wna3M.js").then((e) => n(e.properties));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "ProtoBuf",
    extensions: ["proto"],
    load() {
      return import("./protobuf-BPIjwpzm.js").then((e) => n(e.protobuf));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Puppet",
    extensions: ["pp"],
    load() {
      return import("./puppet-nyd4dhjf.js").then((e) => n(e.puppet));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Q",
    extensions: ["q"],
    load() {
      return import("./q-CGBaP7Rc.js").then((e) => n(e.q));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "R",
    alias: ["rscript"],
    extensions: ["r", "R"],
    load() {
      return import("./r-CSvg8nEZ.js").then((e) => n(e.r));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "RPM Changes",
    load() {
      return import("./rpm-IznJm2Xc.js").then((e) => n(e.rpmChanges));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "RPM Spec",
    extensions: ["spec"],
    load() {
      return import("./rpm-IznJm2Xc.js").then((e) => n(e.rpmSpec));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Ruby",
    alias: ["jruby", "macruby", "rake", "rb", "rbx"],
    extensions: ["rb"],
    filename: /^(Gemfile|Rakefile)$/,
    load() {
      return import("./ruby-C_XUOA8z.js").then((e) => n(e.ruby));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "SAS",
    extensions: ["sas"],
    load() {
      return import("./sas-C8a6XTf7.js").then((e) => n(e.sas));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Scala",
    extensions: ["scala"],
    load() {
      return import("./clike-BVPm0PS8.js").then((e) => n(e.scala));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Scheme",
    extensions: ["scm", "ss"],
    load() {
      return import("./scheme-BJ0wmRxu.js").then((e) => n(e.scheme));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Shell",
    alias: ["bash", "sh", "zsh"],
    extensions: ["sh", "ksh", "bash"],
    filename: /^PKGBUILD$/,
    load() {
      return import("./shell-BP1uvqQm.js").then((e) => n(e.shell));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Sieve",
    extensions: ["siv", "sieve"],
    load() {
      return import("./sieve-c19PZ6IM.js").then((e) => n(e.sieve));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Smalltalk",
    extensions: ["st"],
    load() {
      return import("./smalltalk-Bhddl2pB.js").then((e) => n(e.smalltalk));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Solr",
    load() {
      return import("./solr-pyaw2kD_.js").then((e) => n(e.solr));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "SML",
    extensions: ["sml", "sig", "fun", "smackspec"],
    load() {
      return import("./mllike-1yy7Y7jE.js").then((e) => n(e.sml));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "SPARQL",
    alias: ["sparul"],
    extensions: ["rq", "sparql"],
    load() {
      return import("./sparql-CDM6AtpT.js").then((e) => n(e.sparql));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Spreadsheet",
    alias: ["excel", "formula"],
    load() {
      return import("./spreadsheet-C-cy4P5N.js").then((e) => n(e.spreadsheet));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Squirrel",
    extensions: ["nut"],
    load() {
      return import("./clike-BVPm0PS8.js").then((e) => n(e.squirrel));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Stylus",
    extensions: ["styl"],
    load() {
      return import("./stylus-UHhHrV1-.js").then((e) => n(e.stylus));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Swift",
    extensions: ["swift"],
    load() {
      return import("./swift-CjpkftGe.js").then((e) => n(e.swift));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "sTeX",
    load() {
      return import("./stex-CL7qydVb.js").then((e) => n(e.stex));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "LaTeX",
    alias: ["tex"],
    extensions: ["text", "ltx", "tex"],
    load() {
      return import("./stex-CL7qydVb.js").then((e) => n(e.stex));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "SystemVerilog",
    extensions: ["v", "sv", "svh"],
    load() {
      return import("./verilog-pXaz5sWa.js").then((e) => n(e.verilog));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Tcl",
    extensions: ["tcl"],
    load() {
      return import("./tcl-BDJ3p7IU.js").then((e) => n(e.tcl));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Textile",
    extensions: ["textile"],
    load() {
      return import("./textile-DI6wJbYH.js").then((e) => n(e.textile));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "TiddlyWiki",
    load() {
      return import("./tiddlywiki-BB3MLoWB.js").then((e) => n(e.tiddlyWiki));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Tiki wiki",
    load() {
      return import("./tiki-fxz2Bm0c.js").then((e) => n(e.tiki));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "TOML",
    extensions: ["toml"],
    load() {
      return import("./toml-BHiuTcfn.js").then((e) => n(e.toml));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Troff",
    extensions: ["1", "2", "3", "4", "5", "6", "7", "8", "9"],
    load() {
      return import("./troff-C82vBwtZ.js").then((e) => n(e.troff));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "TTCN",
    extensions: ["ttcn", "ttcn3", "ttcnpp"],
    load() {
      return import("./ttcn-DyphtZKB.js").then((e) => n(e.ttcn));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "TTCN_CFG",
    extensions: ["cfg"],
    load() {
      return import("./ttcn-cfg-3QujkPa7.js").then((e) => n(e.ttcnCfg));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Turtle",
    extensions: ["ttl"],
    load() {
      return import("./turtle-CNoyORAM.js").then((e) => n(e.turtle));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Web IDL",
    extensions: ["webidl"],
    load() {
      return import("./webidl-D9JSZ9MQ.js").then((e) => n(e.webIDL));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "VB.NET",
    extensions: ["vb"],
    load() {
      return import("./vb-c2kQGd6-.js").then((e) => n(e.vb));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "VBScript",
    extensions: ["vbs"],
    load() {
      return import("./vbscript-Dz1TtKsy.js").then((e) => n(e.vbScript));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Velocity",
    extensions: ["vtl"],
    load() {
      return import("./velocity-g1rllD1b.js").then((e) => n(e.velocity));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Verilog",
    extensions: ["v"],
    load() {
      return import("./verilog-pXaz5sWa.js").then((e) => n(e.verilog));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "VHDL",
    extensions: ["vhd", "vhdl"],
    load() {
      return import("./vhdl-BlwxOp5x.js").then((e) => n(e.vhdl));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "XQuery",
    extensions: ["xy", "xquery"],
    load() {
      return import("./xquery-CqGOBEFc.js").then((e) => n(e.xQuery));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Yacas",
    extensions: ["ys"],
    load() {
      return import("./yacas-CKCrqNv2.js").then((e) => n(e.yacas));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Z80",
    extensions: ["z80"],
    load() {
      return import("./z80-g9hQe8EA.js").then((e) => n(e.z80));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "MscGen",
    extensions: ["mscgen", "mscin", "msc"],
    load() {
      return import("./mscgen-Cpl0NYLN.js").then((e) => n(e.mscgen));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Xù",
    extensions: ["xu"],
    load() {
      return import("./mscgen-Cpl0NYLN.js").then((e) => n(e.xu));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "MsGenny",
    extensions: ["msgenny"],
    load() {
      return import("./mscgen-Cpl0NYLN.js").then((e) => n(e.msgenny));
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Vue",
    extensions: ["vue"],
    load() {
      return import("./index-DCxUt2Ke.js").then((e) => e.vue());
    }
  }),
  /* @__PURE__ */ t.of({
    name: "Angular Template",
    load() {
      return import("./index-By20AJok.js").then((e) => e.angular());
    }
  })
];
var T = Object.defineProperty, M = Object.getOwnPropertyDescriptor, l = (e, o, r, s) => {
  for (var i = s > 1 ? void 0 : s ? M(o, r) : o, d = e.length - 1, h; d >= 0; d--)
    (h = e[d]) && (i = (s ? h(o, r, i) : h(i)) || i);
  return s && i && T(o, r, i), i;
};
const _ = /* @__PURE__ */ Object.assign({
  "../node_modules/thememirror/dist/themes/amy.js": () => import("./amy-D8aP2lFO.js"),
  "../node_modules/thememirror/dist/themes/ayu-light.js": () => import("./ayu-light-B3LY0e97.js"),
  "../node_modules/thememirror/dist/themes/barf.js": () => import("./barf-BlAUq6GU.js"),
  "../node_modules/thememirror/dist/themes/bespin.js": () => import("./bespin-B5uBtoDk.js"),
  "../node_modules/thememirror/dist/themes/birds-of-paradise.js": () => import("./birds-of-paradise-DJaYKFWe.js"),
  "../node_modules/thememirror/dist/themes/boys-and-girls.js": () => import("./boys-and-girls-DtPVgHfv.js"),
  "../node_modules/thememirror/dist/themes/clouds.js": () => import("./clouds-CcyD2b80.js"),
  "../node_modules/thememirror/dist/themes/cobalt.js": () => import("./cobalt-tc8vsqpR.js"),
  "../node_modules/thememirror/dist/themes/cool-glow.js": () => import("./cool-glow-Dv2m8FzG.js"),
  "../node_modules/thememirror/dist/themes/dracula.js": () => import("./dracula-B6phppNb.js"),
  "../node_modules/thememirror/dist/themes/espresso.js": () => import("./espresso-DpuUOooN.js"),
  "../node_modules/thememirror/dist/themes/noctis-lilac.js": () => import("./noctis-lilac-CvJSEAs0.js"),
  "../node_modules/thememirror/dist/themes/rose-pine-dawn.js": () => import("./rose-pine-dawn-CmUAgWkf.js"),
  "../node_modules/thememirror/dist/themes/smoothy.js": () => import("./smoothy-Cduwm7Y1.js"),
  "../node_modules/thememirror/dist/themes/solarized-light.js": () => import("./solarized-light-BexU3Czq.js"),
  "../node_modules/thememirror/dist/themes/tomorrow.js": () => import("./tomorrow-DIlucNLk.js")
});
async function D(e) {
  const o = _[`../node_modules/thememirror/dist/themes/${e}.js`];
  if (!o)
    return null;
  const r = await o();
  return Object.values(r)[0];
}
let m = class extends y {
  constructor() {
    super(...arguments), this.view = null, this.editorRef = g(), this.language = "", this.code = "", this.theme = "", this.readOnly = !1;
  }
  update(e) {
    var o;
    if (super.update(e), this.view && e.has("code")) {
      if (((o = this.view) == null ? void 0 : o.state.doc.toString()) === this.code)
        return;
      this.view.dispatch({
        changes: {
          from: 0,
          to: this.view.state.doc.length,
          insert: this.code
        }
      });
    }
  }
  async firstUpdated() {
    const e = [k];
    if (this.language) {
      const r = P.find((s) => s.alias.includes(this.language));
      if (r) {
        const { extension: s } = await r.load();
        e.push(s);
      }
    }
    if (this.readOnly && e.push(S.readOnly.of(!0)), this.theme) {
      const r = await D(this.theme);
      r && e.push(r);
    }
    const o = u.updateListener.of((r) => {
      if (!r.docChanged)
        return;
      this.code = r.state.doc.toString();
      const s = new CustomEvent("code-change", {
        detail: {
          code: this.code
        },
        bubbles: !0,
        composed: !0
      });
      this.dispatchEvent(s);
    });
    e.push(o), e.push(
      j.of([
        {
          key: "Tab",
          preventDefault: !0,
          run: v
        },
        {
          key: "Shift-Tab",
          preventDefault: !0,
          run: b
        }
      ]),
      u.lineWrapping
    ), this.view = new u({
      doc: this.code,
      extensions: e,
      parent: this.editorRef.value
    });
  }
  render() {
    return L`<div id="root" ${w(this.editorRef)}></div>`;
  }
};
m.styles = x`
    :host {
      display: block;
    }

    #root {
      height: 100%;
      width: 100%;
    }

    .cm-editor {
      height: 100%;
      width: 100%;
    }

    .cm-scroller {
      overflow: auto;
    }
  `;
l([
  p()
], m.prototype, "language", 2);
l([
  p()
], m.prototype, "code", 2);
l([
  p()
], m.prototype, "theme", 2);
l([
  p({ type: Boolean })
], m.prototype, "readOnly", 2);
m = l([
  C("code-mirror")
], m);
export {
  m as CodeMirror
};
